Git post-receive hook not working Git post-receive hook not working bash bash

Git post-receive hook not working


You need more diagnostics, e.g.,

function die {  echo "$*" >&2; exit 1}function checkgit {  [ -d "$1/.git" ] || die "$1 could not possibly be a git repo; $1/.git is not a dir"}

At this point, in the subshell right after the parenthesis, you can try stuff like

set -x # show exactly what's executed (writes to stderr)checkgit ~git/acd ~git/a && checkgit . && git pull ...

You might also consider redirecting the whole stderr of the subshell, e.g.,

( ... ) 2>/tmp/mydiagnosis$$.log

(This is a temporary measure and is OK only if there's no confidential info in the logs.)


OK Silas, your additional info rules out a lot of awkward possibilities. I'm nearing the end of my git fu, but here are some more things to try:

  1. Go into ~git/a and see if you can make it git pull by hand. This should fail.
  2. Got into ~git/a and run git status. This should also fail. If it doesn't, then git is giving you a very bad error message.

If both steps fail, ~git/a is not the clone you thought it was. Rename it, make a new clone, and see if you can get the problem to persist.

If the first step succeeds by hand, then something strange is going on and I'm baffled.

If the first step fails but the second succeeds, you may have a problem with branches:

  • Perhaps repo ~git/a is set to the wrong branch, and your repo needs a branch it doesn't have. Try git branch -a and see if you see something unexpected.

  • Perhaps you have the branch, but it's not properly associated with a remote repository. At this point you have to dive into ~git/a/.git/config, and I don't really know how to explain what you should expect to find there. At that point you will need a real git expert; I just play one on TV.


I recently ran into a similar problem and I think it is related to the environment variables that git sets, specifically the $GIT_DIR variable. If you have that set, all git commands on other repos start to act weirdly. Basically I think that running your git pull inside the hook must be invoked in a neutral shell environment that does not have those odd variables and leads to git confusion, though I haven't figured out how to do that just yet.


unset GIT_DIR is a solution which works for the fatal error you are seeing.

This applies to all scripts in hooks (post-update is another common one), which uses the git command inside it. git command uses the GIT_DIR from env instead of pwd.

See https://stackoverflow.com/a/4100577 for further explanation.